
//Clas for player 
class Creature {
  int x, y, r;
  float vy = 0;
  float vx = 0;
  int directionH = 0; 
  int numloc = 0;
  boolean alive = true;
  boolean win = false;
  boolean borderCheckY = true;
  boolean borderCheckX = true;
  PImage img, green;
  boolean leftKey = false;
  boolean rightKey = false;
  boolean upKey = false;
  boolean downKey = false;
  int previousTime = 0;
  float timePassed = 1000;


  Creature (int _x, int _y, int _r) {
    x = _x;
    y = _y;
    r = _r;
    vy = 0;
    vx = 0;
    img = loadImage("player.png");
  }

  void sound() {
    // function to equate each sound to its respective location, play the sound upon trigger
    if ( locations[0].trigger == true) {
      library.amp(1.0);
    }
    if ( locations[1].trigger == true) {
      palms.amp(1.0);
    }
    if ( locations[2].trigger == true) {
      baraha.amp(1.0);
    }
    if ( locations[3].trigger == true) {
      theatre.amp(1.0);
    }
    if ( locations[4].trigger == true) {
      dining.amp(1.0);
    }
    if ( locations[5].trigger == true) {
      knock.amp(1.0);
    }
    if ( locations[6].trigger == true) {
      alarm.amp(1.0);
    }
  }

  void display() {
    update();
    noFill();
    noStroke();
    image( img, x-r, y-r, 50, 50);
    circle(x, y, r*2);
  }

  void update() {
    keyPressed();

    y += vy;
    x += vx;

    // for movement of the player and keys + game borders
    if ( leftKey == true && x>=0) {
      directionH = 1;
      vx = -1;
    } else if ( rightKey == true && x + r <= 1024) {
      vx = 1;
      directionH = 0;
    } else if ( downKey == true && y +r <= 784) {
      vy = 1;
    } else if ( upKey == true && y >= 0  ) {
      vy = -1;
    } else { 
      vx = 0;
      vy = 0;
    }

    // checking for collision of map borders
    collisionY();
    collisionX();

    for ( int g = 0; g< 3; g++) {
      if (cats[g].distance(x, y) <= r +cats[g].r ) {
        // when player hits a cat
        if (trigger == false) {
          // mouse sound effect + you die, and the sounds stop
          meow.play();
          palms.amp(0.0);
          baraha.amp(0.0);
          library.amp(0.0);
          theatre.amp(0.0);
          dining.amp(0.0);
          knock.amp(0.0);
          alarm.amp(0.0);
          println("meow");
          trigger = true;
          alive = false;
          win = false;
        }
      }
      // if you hit a human, your score goes down, and you lose 10 seconds off your timer
      if (humans[g].distance(x, y) <= r +humans[g].r) {
        if (humans[g].trigger == false) {
          game.count -=10;
          game.scorecount-=20;
          previousTime = millis();
          humans[g].trigger = true;
          game.display();
        }
        if ( millis() > previousTime + timePassed) {
          previousTime= millis();
          humans[g].trigger = false;
        }
      }
    }

    // probably one of the most important parts. Code to see if you hit a location
    for ( int o = 0; o< 7; o++) {
      if (locations[o].trigger == false) {
        if (locations[o].distance(x, y) <= 20) {
          locations[o].trigger = true; 
          if (tally.size() >0) {
            // adds to your score
            numloc +=1;
            game.scorecount += ((120 - (millis()/1000))*creature.numloc);
            println(game.scorecount);
            // removes a string on top left to see how many you have left
            tally.remove(0);
            locations[o].display2();
            // ding as an indicator that you got one
            ding.play();
            sound();
            //image (green, height, width);
            println(tally);
          }
        }
        // check for a win. If the string length == 0, you won
      } else if (tally.size() == 0) {
        win = true;
        alive = false;
      }
    }
  }
  // checking to see if you hit the horizontal borders. makes you stop moving
  void collisionY() {
    for (int i = 0; i <13; i++ ) {
      if ( vy + y + r >= horizentalBorders[i].y && 
        vx + x + r >= horizentalBorders[i].x &&
        x + vx +r <= horizentalBorders[i].x2 && 
        vy + y + r <= horizentalBorders[i].y2) {
        vy = 0;
      }
    }
  }
  // collision with vertical borders.
  void collisionX() {
    for (int j = 0; j < 11; j++) {
      if ( vx + x + (r*2) <= verticalBorders[j].x && 
        vx + x + (r*2) >= verticalBorders[j].x2 &&
        y + vy + r >= verticalBorders[j].y && 
        vy + y + r <= verticalBorders[j].y2) {
        //println("stop3");
        vx = 0;
      }
    }
  }

  // equating key pressed with players movements
  void keyPressed() {
    if (keyPressed && keyCode == LEFT ) {
      leftKey = true;
    } else {
      leftKey = false;
    }
    if (keyPressed && keyCode == RIGHT) { //&& x+r <= game.w
      rightKey = true;
    } else {
      rightKey = false;
    }
    if (keyPressed && keyCode == UP) {
      upKey = true;
    } else {
      upKey = false;
    }
    if (keyPressed && keyCode == DOWN) { // && y+r <= game.h
      downKey = true;
    } else {
      downKey = false;
    }
  }



  float distanceCreature(int tarX, int tarY) {
    return (pow( (pow(( x - tarX), 2) + pow((y - tarY), 2)), 0.5));
  }
}
