int gameScreen = 0;
PImage dead, won, instructions;
boolean trigger = false;
Game game;
Creature creature;
Cats[] cats;
Humans[] humans;
Borders[] horizentalBorders;
Borders[] verticalBorders;
Locations[] locations;
//SoundFile[] sounds;
SoundFile backgroundSound, meow, ding, baraha, alarm, dining, library, knock, palms, theatre;

void setup() {
  //This trigger is just fir the cat meow
  trigger = false;
  creature = new Creature (50, 450, 10);
  game = new Game (1024, 786, 585);
  cats = new Cats[3];
  humans = new Humans[3];
  //for displaying the cats and humans, in random places and speeds
  for ( int g = 0; g< 3; g++) {
    cats[g] = new Cats (int(random(200, 900)), int(random(200, 600)), 15, 70, 70, 200, 800);
    humans[g] = new Humans (int(random(200, 900)), int(random(200, 900)), 15, 70, 70, 200, 800);
  }
  //Creating the locations for the sound to br triggered. These dont change
  locations = new Locations[7];
  locations[0] = new Locations (250, 270, 100); // library
  locations[1] = new Locations ( 250, 470, 100); // Palms
  locations[2] = new Locations (400, 310, 50); //baraha
  locations[3] = new Locations (790, 250, 100); //theatre
  locations[4] = new Locations (950, 400, 100); //dining
  locations[5] = new Locations (800, 620, 200); // knock
  locations[6] = new Locations (570, 570, 200); // alarm
  size(1024, 768);
  background(255, 255, 255);
  //borders of the map, where you cannot enter from
  horizentalBorders = new Borders[14];
  verticalBorders = new Borders[13];
  horizentalBorders[1] = new Borders (444, 286, 575, 286); //h
  horizentalBorders[2] = new Borders (442, 346, 520, 346); //h 
  horizentalBorders[3] = new Borders (402, 470, 502, 470); //h
  horizentalBorders[4] = new Borders (590, 472, 712, 472); //h
  horizentalBorders[5] = new Borders (754, 493, 812, 493); //h
  horizentalBorders[6] = new Borders (70, 175, 440, 175); // h
  horizentalBorders[7] = new Borders (70, 375, 422, 375); //h
  horizentalBorders[8] = new Borders (310, 725, 970, 725); //h
  horizentalBorders[9] = new Borders (530, 527, 586, 527); //h 
  horizentalBorders[10] = new Borders (536, 595, 586, 595); // h
  horizentalBorders[11] = new Borders (350, 614, 396, 614); //h
  horizentalBorders[12] = new Borders (754, 602, 808, 602); // h
  horizentalBorders[0] = new Borders (756, 640, 808, 640); // h
  verticalBorders[12] = new Borders (440, 175, 440, 270); //h
  verticalBorders[1] = new Borders (540, 346, 540, 455); //v
  verticalBorders[2] = new Borders (582, 286, 582, 456);// v
  verticalBorders[3] = new Borders (70, 175, 70, 375); //v
  verticalBorders[4] = new Borders (310, 572, 310, 725); //v
  verticalBorders[5] = new Borders (970, 525, 970, 725);  // v
  verticalBorders[6] = new Borders (775, 675, 775, 720); // v
  verticalBorders[7] = new Borders (800, 675, 800, 720); //v 
  verticalBorders[8] = new Borders (586, 527, 586, 595); // v
  verticalBorders[9] = new Borders (536, 529, 536, 595); //v
  verticalBorders[10] = new Borders (396, 614, 396, 664); //v
  verticalBorders[11] = new Borders (808, 602, 808, 640); // v
  verticalBorders[0] = new Borders (756, 602, 756, 640); // v
  //if you die- page
  dead = loadImage("sorry.png");
  //if you win - page
  won = loadImage("finalpage.png");
  //instructional page
  instructions = loadImage("instructions.png");
  //loading the sounds of the song
  backgroundSound = new SoundFile(this, "OriginalBacktrack.mp3");
  baraha = new SoundFile(this, "CardSwipe.mp3");
  knock= new SoundFile(this, "Knock_RA.mp3");
  theatre = new SoundFile(this, "SneezeCough.mp3");
  library = new SoundFile(this, "Typing_clicking.mp3"); 
  palms = new SoundFile(this, "Birds.mp3");
  dining = new SoundFile(this, "Didyoudothereading.mp3");   
  alarm = new SoundFile(this, "iPhoneAlarm.mp3"); 
  meow = new SoundFile(this, "meow.mp3");
  ding = new SoundFile(this, "Ding.mp3");

//playing all the sounds in loop for easier restart (less bugs), all on mute except background, 
// this is so that whenever they are triggered they are still on tempo for the song
  backgroundSound.play();
  baraha.loop();
  baraha.amp(0.0);
  knock.loop();
  knock.amp(0.0);
  theatre.loop();
  theatre.amp(0.0);
  library.loop();
  library.amp(0.0);
  dining.loop();
  dining.amp(0.0);
  alarm.loop();
  alarm.amp(0.0);
  meow.amp(0.5);
  //restart();
}

void sound() {
  // locating each location for their respective sound, because an array of sounds did not work
  if ( locations[0].trigger == true) {
    library.amp(1.0);
    println("library");
  }
  if ( locations[1].trigger == true) {
    palms.amp(1.0);
  }
  if ( locations[2].trigger == true) {
    baraha.amp(1.0);
  }
  if ( locations[3].trigger == true) {
    theatre.amp(1.0);
  }
  if ( locations[4].trigger == true) {
    dining.amp(1.0);
  }
  if ( locations[5].trigger == true) {
    knock.amp(1.0);
  }
  if ( locations[6].trigger == true) {
    alarm.amp(1.0);
  }
}

void initScreen() {
  //initial screen, instruction page
  image(instructions, 0, 0);
  text("Click anywhere to begin ! ", 300, 700);
}

void restart() {
  // upon restart
  // this was a response to a cat bug
  trigger = false;
  creature = new Creature (50, 450, 10);
  game = new Game (1024, 786, 585);
  cats = new Cats[3];
  humans = new Humans[3];
  for ( int g = 0; g< 3; g++) {
    cats[g] = new Cats (int(random(200, 900)), int(random(200, 600)), 15, 70, 70, 200, 800);
    humans[g] = new Humans (int(random(200, 900)), int(random(200, 900)), 15, 70, 70, 200, 900);
  }
  locations = new Locations[7];
  locations[0] = new Locations (250, 270, 100); // library
  locations[1] = new Locations ( 250, 470, 100); // Palms
  locations[2] = new Locations (400, 310, 50); //baraha
  locations[3] = new Locations (790, 250, 100); //theatre
  locations[4] = new Locations (950, 400, 100); //dining
  locations[5] = new Locations (800, 620, 200); // knock
  locations[6] = new Locations (570, 570, 200); // alarm

  backgroundSound.loop();
  baraha.loop();
  baraha.amp(0.0);
  knock.loop();
  knock.amp(0.0);
  theatre.loop();
  theatre.amp(0.0);
  library.loop();
  library.amp(0.0);
  dining.loop();
  dining.amp(0.0);
  alarm.loop();
  alarm.amp(0.0);
  //meow.loop();
  meow.amp(0.5);
}

void draw () {
  // to make it easier which game scteen we are on
  if (gameScreen == 0) {
    // instructions page
    initScreen();
  } else if (gameScreen == 1) {
    // the game
    gameScreen();
  } else if (gameScreen == 2) {
    // if you lose
    gameOverScreen();
  } else if (gameScreen == 3) {
    // if you win
    gameWinScreen();
  }
}

void gameScreen() {
  game.display();
  creature.display();
  for ( int g = 0; g< 3; g++) {
    cats[g].display();
    humans[g].display();
  }
  for ( int n = 0; n < 12; n ++) {
    horizentalBorders[n].displayBorders();
  }
  for ( int m = 0; m < 13; m ++) {
    verticalBorders[m].displayBorders();
  }
  for ( int l = 0; l <7; l ++) {
    // checking if the locations are triggered
    locations[l].display();
    locations[l].trigger();
  }
  if (game.count <= 0) {
    // if the time runs our, you lose
    creature.alive = false; 
    creature.win = false;
  }
  if (creature. alive == false && creature.win == true) {
    // if you win
    gameScreen=3 ;
    gameWinScreen();
  }
  if (creature. alive == false && creature.win == false) {
    // if you lose
    gameScreen=2 ;
    gameOverScreen();
  }
}

void gameOverScreen() {
  // lost screen
  image (dead, 187, 59);
}
void gameWinScreen() {
  // won screen, dsplaying score as well
  image (won, 187, 59);
  text("Your Score: " + int(game.scorecount), 420, 420);
}

void mouseClicked() {
  if ( gameScreen == 0) {
    gameScreen= 1;
  }
  if (gameScreen == 2 || gameScreen == 3) {
    restart();
    gameScreen= 1;
    println("restart");
  }
}
